#include <stdio.h>
#include <ctype.h>
/*#include <stdlib.h>*/


FILE *inf;
int n,t,sat,seed;
int ch,*br,**pbr;
char *lfd,*sp;

void usage(),getval(),initbr(),getbr(),optbr(),countbr();

main(argc,argv)
     int argc;
     char **argv;
{
   if(argc!=2)
     {
	usage(argv);
	exit(-1);
     }
   if((inf=fopen(*(argv+1),"r"))==NULL)
     {
	fprintf(stderr,"Cannot open FILE : %s\n",*(argv+1));
	usage(argv);
	exit(-1);
     }
#ifdef DEBUG
   printf("open ok\n");
#endif
   n=0; t=0; sat=0,seed=0;
   lfd="\n";
   sp=" ";
#ifdef DEBUG
   printf("init ok\n");
#endif
   getval(&n);
#ifdef DEBUG
   printf("n= %d\n",n);
#endif
   getval(&t);
#ifdef DEBUG
   printf("t= %d\n",t);
#endif
   getval(&sat);
#ifdef DEBUG
   printf("sat= %d\n",sat);
#endif
   getval(&seed);
#ifdef DEBUG
   printf("seed= %d\n",seed);
#endif
   initbr();
   getbr();
   optbr();
   countbr();
   free(br);
   fclose(inf);
}

void usage(argv)
     char **argv;
{
   fprintf(stderr,"usage : %s <Inputfile>\n",*argv);
   exit(-1);
}

void initbr()
{
   int i;

   br=(int *)malloc(sizeof(int)*2*n*2*n);
   pbr=(int **)malloc(sizeof(int *)*2*n);
   for(i=0; i<(2*n*2*n); i++)
     {
	*(br+i)=0;
     }
#ifdef DEBUG
   printf("br ok\n");
#endif
   for(i=0; i<2*n; i++)
     {
	*(pbr+i)=br+2*n*i;
#ifdef DEBUG
	printf("pbr[%d],%d\n",i,*(pbr+i));
#endif
     }
}

void getval(number)
     int *number;
{
   int tmpval,patern;

   patern=0;
   if(feof(inf)!=0)
     {
	fprintf(stderr,"Get value Fail\n");
	exit(-1);
     }
   tmpval=0;
   ch=fgetc(inf);
   if(ch=='-')
     {
	patern=1;
	ch=fgetc(inf);
     }
/*   while((ch!=*lfd)&&(ch!=*sp))*/
   while(isdigit(ch))
     {
	tmpval=tmpval*10;
	tmpval+=ch-'0';
	ch=fgetc(inf);
#ifdef DEBUG
	printf("tmpval= %d",tmpval);
#endif
     }
   if(patern==1)
     *number=-tmpval;
   else
     *number=tmpval;
}


void getbr()
{
   int i,j,v1,v2,v3,e1,e2,e3;

   for(i=0; i<t; i++)
     {
#ifdef DEBUG
	printf("while\n");
#endif
	getval(&v1);
	getval(&v2);
	getval(&v3);
	if(v1<0)
	  e1=abs(v1)+n-1;
	else
	  e1=v1-1;
	if(v2<0)
	  e2=abs(v2)+n-1;
	else
	  e2=v2-1;
	if(v3<0)
	  e3=abs(v3)+n-1;
	else
	  e3=v3-1;
#ifdef DEBUG
	printf("v1= %d v2=%d v3=%d\n",v1,v2,v3);
	printf("e1= %d e2=%d e3=%d\n",e1,e2,e3);
#endif
	*(*(pbr+e1)+e2)+=1;
	*(*(pbr+e1)+e3)+=1;
	*(*(pbr+e2)+e3)+=1;

	ch=fgetc(inf);
     }
#ifdef DEBUG
   for(i=0; i<2*n; i++)
     {
	for(j=0; j<2*n; j++)
	  {
	     printf("br[%d][%d]= %d\n",i+1,j+1,pbr[i][j]);
	  }
     }
   printf("\n");
#endif   
}

void optbr()
{
   int i,j;

   for(i=0; i<2*n; i++)
     {
	for(j=i; j<2*n; j++)
	  {
	     if(i!=j)
	       {
		  pbr[i][j]+=pbr[j][i];
		  pbr[j][i]=0;
	       }
	  }
     }
#ifdef DEBUG
   for(i=0; i<2*n; i++)
     {
	for(j=0; j<2*n; j++)
	  {
	     printf("br[%d][%d]= %d\n",i+1,j+1,pbr[i][j]);
	  }
     }
#endif   
}

void countbr()
{
   int i,j,count;

   count=0;
   for(i=0; i<2*n; i++)
     {
	for(j=i; j<2*n; j++)
	  {
	     if(pbr[i][j]>0)
	       count+=1;
	  }
     }
   printf("The number of edges : %d\n",count);
}
