#include <stdio.h>
#include <stdlib.h>
#include <errno.h>
#include <sys/types.h>
#include <sys/time.h>
#include <sys/timeb.h>

#include "head.h"

int *nv,*s_nv,*p_nv,*n_nv,*ps_nv,*ns_nv,*tmpclause,*hclause,
  **ptmpclause,**phclause,*rsell,*rselc,*rselc2,*clause,
  **pclause,*rselop,*rlit,*tmpnv,*hnv;

int n,literals,s_literals,t,presentt,dn,tt,tmplit;

void keep_area(),set_p(),init(),make_no(),operate(),find_min_c(),
  resolve_c(),remove_c(),step4(),fail_out(),fail_pred(),change_pred(),
  dimacs_no();

int sel_lit_pn(),chk_nv(),select_lit(),handle_0(),del_lit(),chk_del_c(),
  handle_2(),chk_predicate(),handle_3(),rmake_c(),rand_make_c();

main(argc,argv)
     int argc;
     char **argv;
{
   int selin;

   init_1();
   printf("\n*****  %dSAT-Generator for Unsatisfiable CNF Predicates *****\n\n",XSAT);
   if(argc > 2)
     {
	printf("Usage: %s {number}\n",*argv);
	exit(-1);
     }
   else
     {
	if(argc == 2)
	  {
	     n=chg_num(*(argv+1));
	     if((n<=0)||(n>MAX_LIT))
	       {
		  printf("Argument's value isn't between 1 and %d\n",
			 MAX_LIT);
		  exit(-1);
	       }
	  }
	else
	  do
	    {
	       printf("How many variables ? 1 ... %d   ",
		      MAX_LIT);
	       scanf("%d",&n);
	    }while((n<=0)||(n>MAX_LIT));
     }
   keep_area1();
   set_p1();
   do
     {
	printf("Literal Distribution\n");
	printf("   (0) Specify Literal Distribution\n");
	printf("   (1) Flat Distribution\n");
	printf("   (2) Normal Distribution\n");
	printf("   (3) Input Ratio(Clause/Variable)\n");
	printf("Select[ 0 - 3 ]:   ");
	scanf("%d",&selin);
     }while((selin<0)||(selin>3));
   switch(selin)
     {
      case 0: in_num_lit(); break;
      case 1: in_same_dat(); break;
      case 2: seiki_bunpu(); break;
      case 3: ratio_in(); break;
     }
   init_2();
   keep_area();
   keep_area2();
   set_p();
   set_p2();
   init_3();
   init();
   make_no();
   operate();
}

void keep_area()
{
  if((tmpclause=(int *)malloc(sizeof(int)*(2*n+1)*(t+DN)))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((ptmpclause=(int **)malloc(sizeof(int *)*(t+DN)))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((hclause=(int *)malloc(sizeof(int)*(2*n+1)*(t+DN)))==NULL)
    {
       perror("malloc\n");
       exit(-1);
    }
  if((phclause=(int **)malloc(sizeof(int *)*(2*n+1)*(t+DN)))==NULL)
    {
       perror("malloc\n");
       exit(-1);
    }
  if((rselc=(int *)malloc(sizeof(int)*(t+DN+1)))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((rselc2=(int *)malloc(sizeof(int)*(t+DN+1)))==NULL)
     {
	perror("malloc\n");
	exit(-1);
     }
  if((rselop=(int *)malloc(sizeof(int)*4))==NULL)
    {
       perror("malloc\n");
       exit(-1);
    }
  if((tmpnv=(int *)malloc(sizeof(int)*2*n))==NULL)
    {
       perror("malloc\n");
       exit(-1);
    }
  if((hnv=(int *)malloc(sizeof(int)*2*n))==NULL)
    {
       perror("malloc\n");
       exit(-1);
    }
}

void set_p()
{
   int i;
   
   for(i=0; i<(t+DN); i++)
     {
	*(ptmpclause+i)=tmpclause+(2*n+1)*i;
	*(phclause+i)=hclause+(2*n+1)*i;
     }
}

void init()
{
   int i;

   presentt=0;
   dn=0;
   tt=0;
   tmplit=0;
   for(i=0; i<(t+DN); i++)
     {
	fill_dat(*(ptmpclause+i),(2*n+1),0);
	fill_dat(*(phclause+i),(2*n+1),0);
     }
   fill_dat(rselc,t+DN+1,0);
   fill_dat(rselc2,t+DN+1,0);
   fill_dat(rselop,4,0);
   fill_dat(tmpnv,2*n,0);
   fill_dat(hnv,2*n,0);
}

int sel_lit_pn(numlit)
     int *numlit;
{
   int tmp,tmpp,failed;

   failed=1;
   fill_dat(rsell,n+1,1);
   tmp=num_rand(0,*(rsell+n));
   tmpp=*(rsell+tmp);
   while(((*(p_nv+tmpp)==0)||(*(n_nv+tmpp)==0))&&(*(rsell+n)!=0))
     {
	removel(rsell,tmp,*(rsell+n),n);
	if(*(rsell+n)!=0)
	  {
	     tmp=num_rand(0,*(rsell+n));
	     tmpp=*(rsell+tmp);
	  }
     }
   if(*(rsell+n)==0)
     {
	failed=0;
     }
   else
     {
     }
   *numlit=tmpp;
   return failed;
}

void make_no()
{
   int tmpp,selok;

   if((selok=sel_lit_pn(&tmpp))==0)
     {
	printf("Any predicates are satisfiable.\n");
	exit(-1);
     }
   *(*(ptmpclause)+tmpp)=1;
   *(*(ptmpclause+1)+tmpp+n)=1;
   *(*(ptmpclause)+(2*n))=1;
   *(*(ptmpclause+1)+(2*n))=1;
   *(p_nv+tmpp)-=1;
   *(n_nv+tmpp)-=1;
   literals-=2;
   presentt+=2;
}

void operate()
{
   int se,sel,fin,litdis,progress,ppro;

   fin=0;
   fill_dat(rselop,4,1);
   sel=0; se=sel; 
   progress=0; ppro=0; 
   printf("\n");
   while((fin==0)&&(*(rselop+3)!=0))
     {
	se=num_rand(0,*(rselop+3)); 
	sel=*(rselop+se); 
	switch(sel)
	  {
	   case 0: 
	     {
		if(presentt<(t+DN-dn))
		  {
		     if(handle_0()==0)
		       {
			  removel(rselop,se,*(rselop+3),3);
		       }
		     else
		       {
			  fill_dat(rselop,4,1);
		       }
		  }
		else
		  {
		    if(presentt==(t+DN-dn))
		      {
			printf("clause is more \n");
			removel(rselop,se,*(rselop+3),3);
		      }
		    else
		      {
			printf(" Failed because of number of clause \n");
			fail_out();
			fail_pred();
		      }
		  }
		break;
	     }
	   case 1:
	     {
		removel(rselop,se,*(rselop+3),3);
		break;
	     }
	   case 2: 
	     {
		if(handle_2()==0)
		  {
		     removel(rselop,se,*(rselop+3),3);
		  }
		else
		  {
		     fill_dat(rselop,4,1);
		  }
		break;
	     }
	  }
	if(ppro==0)
	  {
	     ppro=(presentt*100)/t;
	  }
	else
	  {
	     progress=(presentt*100)/t;
	  }
	if(ppro<progress)
	  {
	     ppro=progress;
	     if(ppro%5==0)
	       {
		  printf("    %d %%  \n",progress);
	       }
	  }
	if(presentt>t)
	  {
	     fail_out();
	     fail_pred();
	     exit(-1);
	  }
	if((litdis=handle_3())==2)
	  {
	     printf("Output Predicate\n");
	     fin=1;
	     out_lit();
	     out_pred();
	     dimacs_no();
	     dimacs_out();
	  }
	else
	  {
	     if(litdis==1)
	       {
		 int i;

		  if(dn>(FINISH_DN*DN))
		    {
		       fin=1;
		       step4();
		    }
		  else
		    {
		    }
	       }
	     else
	       {
	       }
	  }
    }
   if(*(rselop+3)==0)
     {
	if(tt!=0)
	  {
	     change_pred();
/*	     rand_make_c();*/
	     printf("Clause Remove: %d\n",dn);
	     step4();
	  }
	else
	  {
	     printf("Halt with no output\n");
	     fail_out();
	     fail_pred();
	     exit(-1);
	  }
     }
   printf("\n");
}

void resolve_c(position,numl)
     int position,numl;
{
   int i,inclease,tmp;

   inclease=0;
   for(i=(presentt-1); i>=position; i--)
     {
	copy_dat(*(ptmpclause+i),*(ptmpclause+i+1),(2*n+1));
     }
   for(i=0; i<2*n; i++)
     {
	tmp= (*(*(ptmpclause+position)+i));
	if(tmp>0)
	  {
	     *(nv+i)-=tmp;
	     inclease+=tmp;
	  }
     }
   literals-=inclease;
   *(*(ptmpclause+position)+numl)+=1;
   *(*(ptmpclause+position+1)+n+numl)+=1;
   *(*(ptmpclause+position)+2*n)+=1;
   *(*(ptmpclause+position+1)+2*n)+=1;
   *(p_nv+numl)-=1;
   *(n_nv+numl)-=1;
   literals-=2; 
   presentt+=1;
}

int chk_nv(numl)
     int *numl;
{
   int i,tmp;

   tmp=0;
   for(i=0; (i<2*n)&&(tmp==0); i++)
     {
	if(*(nv+i)<0)
	  {
	     *numl=i;
	     tmp=1;
	  }
     }
   return tmp;
}

void find_min_c(numc)
     int *numc;
{
   int i,min,countc,sel;

   min=0;
   countc=0;
   fill_dat(rselc,t+DN+1,0);
   for(i=0; i<presentt; i++)
     {
	if(min==0)
	  {
	     min=*(*(ptmpclause+i)+2*n);
	     *(rselc)=i;
	     countc=1;
	  }
	else
	  {
	     if(*(*(ptmpclause+i)+2*n)==min)
	       {
		  *(rselc+countc)=i;
		  countc+=1;
	       }
	     else
	       {
		  if(*(*(ptmpclause+i)+2*n)<min)
		    {
		       fill_dat(rselc,t+DN+1,0);
		       min=*(*(ptmpclause+i)+2*n);
		       *(rselc)=i;
		       countc=1;
		    }
	       }
	  }
     }
   sel=num_rand(0,countc);
   *numc=*(rselc+sel);
}

int select_lit(numc,numl)
     int numc,*numl;
{
  int sel,ll,find;

  find=0;
  fill_dat(rsell,n+1,1);
  while((find==0)&&(*(rsell+n)!=0))
    {
      sel=num_rand(0,*(rsell+n));
      ll=*(rsell+sel);
      if((*(*(ptmpclause+numc)+ll)>0)||(*(*(ptmpclause+numc)+n+ll)>0))
	{
	  removel(rsell,sel,*(rsell+n),n);
	}
      else
	{
	  *numl=ll;
	  find=1;
	}
    }
  return find;
}


int handle_0()
{
   int tmpp,selc,exceedl,failed,seldel,sel,delc,i,tdn,tlit,tpret;
   int count,finresolve;

   failed=0;
   finresolve=0;
   for(count=0; ((count<10)&&(finresolve==0)); count++)
     {
	for(i=0; i<(t+DN); i++)
	  fill_dat(*(phclause+i),(2*n+1),0);
	for(i=0; i<(t+DN); i++)
	  copy_dat(*(ptmpclause+i),*(phclause+i),(2*n+1));
	copy_dat(nv,hnv,2*n);
	tdn=dn; tlit=literals; tpret=presentt;
	if(tt>0)
	  {
	    selc=num_rand(0,presentt);
	  }
	else
	  {
	     find_min_c(&selc);
	  }
	if(select_lit(selc,&tmpp)==0)
	  {
	    failed=0;
	  }
	else
	  {
	    failed=1;
	    resolve_c(selc,tmpp);
	  }
	while(chk_nv(&exceedl)&&(failed==1))
	  {
	     seldel=num_rand(0,2);
	     sel=num_rand(0,2);
	     delc=selc+sel;
	     if(seldel==0)
	       {
		  if(del_lit(1,exceedl)==0)
		    {
		       if(chk_del_c(1,&delc)==1)
			 {
			    if(DN==-1)
			      {
				 remove_c(delc);
				 dn+=1;
			      }
			    else
			      {
				 if(dn<DN)
				   {
				      remove_c(delc);
				      dn+=1;
				   }
				 else
				   {
				      failed=0;
				   }
			      }
			 }
		       else
			 {
			    delc=selc+(1-sel);
			    if(chk_del_c(1,&delc)==1)
			      {
				 if(DN==-1)
				   {
				      remove_c(delc);
				      dn+=1;
				   }
				 else
				   {
				      if(dn<DN)
					{
					   remove_c(delc);
					   dn+=1;
					}
				      else
					{
					   failed=0;
					}
				   }
			      }
			    else
			      {
				 failed=0;
			      }
			 }
		    }
	       }
	     else
	       {
		  if(chk_del_c(1,&delc)==1)
		    {
		       if(DN==-1)
			 {
			    remove_c(delc);
			    dn+=1;
			 }
		       else
			 {
			    if(dn<DN)
			      {
				 remove_c(delc);
				 dn+=1;
			      }
			    else
			      {
				 failed=0;
			      }
			 }
		    }
		  else
		    {
		       delc=selc+(1-sel);
		       if(chk_del_c(1,&delc)==1)
			 {
			    if(DN==-1)
			      {
				 remove_c(delc);
				 dn+=1;
			      }
			    else
			      {
				 if(dn<DN)
				   {
				      remove_c(delc);
				      dn+=1;
				   }
				 else
				   {
				      failed=0;
				   }
			      }
			 }
		       else
			 {
			    if(del_lit(1,exceedl)==0)
			      {
				 failed=0;
			      }
			 }
		    }
	       }
	  }
	if(failed==0)
	  {
	     for(i=0; i<(t+DN); i++)
	       copy_dat(*(phclause+i),*(ptmpclause+i),(2*n+1));
	     copy_dat(hnv,nv,2*n);
	     dn=tdn; literals=tlit; presentt=tpret;
	  }
	else
	  {
	     finresolve=1;
	  }
     }
   return failed;
}

int del_lit(patern,numlit)
     int patern,numlit;
{
   int finish,tmpt,selc,position,tmp,tmpp;

   finish=0;
   tmpt=presentt;
   fill_dat(rselc,tmpt,1);
   *(rselc+t+DN)=tmpt;
   while((tmpt>0)&&(finish==0))
     {
	selc=num_rand(0,tmpt);
	position=*(rselc+selc);
	if(((tt==0)&&(*(*(ptmpclause+position)+2*n)>1))
	  ||((tt>0)&&(*(*(ptmpclause+position)+2*n)>XSAT)))
	  {
	     if(patern==0)
	       {
		  fill_dat(rlit,2*n+1,1);
		  while((*(*(ptmpclause+position)+2*n)>XSAT)
			&&(*(rlit+2*n)>0))
		    {
		       tmp=num_rand(0,*(rlit+2*n));
		       tmpp=*(rlit+tmp);
		       if(*(*(ptmpclause+position)+tmpp)>0)
			 {
			    *(*(ptmpclause+position)+tmpp)-=1;
			    *(*(ptmpclause+position)+2*n)-=1;
			    *(nv+tmpp)+=1;
			    literals+=1;
			 }
		       else
			 {
			    removel(rlit,tmp,*(rlit+2*n),2*n);
			    tmpt-=1;
			 }
		    }
		  finish=1;
	       }
	     else
	       {
		  if(*(*(ptmpclause+position)+numlit)>0)
		    {
		       *(*(ptmpclause+position)+numlit)-=1;
		       *(*(ptmpclause+position)+2*n)-=1;
		       *(nv+numlit)+=1;
		       literals+=1;
		       finish=1;
		    }
		  else
		    {
		       removel(rselc,selc,tmpt,(t+DN));
		       tmpt-=1;
		    }
	       }
	  }
	else
	  {
	     removel(rselc,selc,tmpt,(t+DN));
	     tmpt-=1;
	  }
     }
   return finish;
}
		     
int chk_del_c(patern,numc)
     int patern,*numc;
{
   int tmpd,seld,tmpc,selc,delete,cover,findc,nocover,i;

   findc=0;
   nocover=0;
   tmpd=presentt;
   if(patern==0)
     {
	fill_dat(rselc2,tmpd,1);
	*(rselc2+t+DN)=tmpd;
     }
   do
     {
	tmpc=presentt;
	fill_dat(rselc,tmpc,1);
	*(rselc+t+DN)=tmpc;
	if(patern==0)
	  {
	     seld=num_rand(0,tmpd);
	     delete=*(rselc2+seld);
	  }
	else
	  {
	     delete=*numc;
	  }
	while((findc==0)&&(tmpc>0))
	  {
	     selc=num_rand(0,tmpc);
	     cover=*(rselc+selc);
	     if(cover==delete)
	       {
		  removel(rselc,selc,tmpc,t+DN);
		  tmpc-=1;
	       }
	     else
	       {
		  if(*(*(ptmpclause+delete)+2*n)<
		     *(*(ptmpclause+cover)+2*n))
		    {
		       removel(rselc,selc,tmpc,t+DN);
		       tmpc-=1;
		    }
		  else
		    {
		       nocover=0;
		       for(i=0; ((i<2*n)&&(nocover==0)); i++)
			 {
			    if(*(*(ptmpclause+cover)+i)>0)
			      {
				 if(*(*(ptmpclause+delete)+i)==0)
				   {
				      removel(rselc,selc,tmpc,t+DN);
				      tmpc-=1;
				      nocover=1;
				   }
			      }
			 }
		       if(nocover==1)
			 {
			 }
		       else
			 {
			    findc=1;	
			 }
		    }
	       }
	  }
	if(findc==0)
	  {
	     if(patern==0)
	       {
		  removel(rselc2,seld,tmpd,t+DN);
		  tmpd-=1;
	       }
 	  }
     }while((patern==0)&&(findc==0)&&(tmpd>0));
   if(patern==0)
     {
	*numc=delete;
     }
   return findc;
}

void remove_c(numc)
     int numc;
{
   int i;

   for(i=0; i<2*n; i++)
     {
	if(*(*(ptmpclause+numc)+i)>0)
	  {
	     *(nv+i)+=*(*(ptmpclause+numc)+i);
	  }
     }
   literals+=*(*(ptmpclause+numc)+2*n);
   presentt-=1;
   for(i=numc; i<presentt; i++)
     {
	copy_dat(*(ptmpclause+i+1),*(ptmpclause+i),2*n+1);
     }
   fill_dat(*(ptmpclause+presentt),2*n+1,0);
}

int handle_2()
{
   int numc;

   if(chk_del_c(0,&numc)==0)
      {
	 return 0;
      }
   else
     {
	if(DN==-1)
	  {
	     remove_c(numc);
	     dn+=1;
	     return 1;
	  }
	else
	  {
	     if(dn<DN)
	       {
		  remove_c(numc);
		  dn+=1;
		  return 1;
	       }
	     else
	       {
		  return 0;
	       }
	  }
     }
}

int chk_predicate()
{
   int i,ok;

   ok=1;
   for(i=0; ((i<presentt)&&(ok==1)); i++)
     {
	if(*(*(ptmpclause+i)+2*n)!=XSAT)
	  {
	     ok=0;
	  }
     }
   return ok;
}

int handle_3()
{
   int i,val;

   if(chk_predicate()==0)
     {
        val=0;
     }
   else
     {
	for(i=0; i<t; i++)
	  {
	     fill_dat(*(pclause+i),2*n+1,0);
	  }
	for(i=0; i<presentt; i++)
	  {
	     copy_dat(*(ptmpclause+i),*(pclause+i),2*n+1);
	  }
	copy_dat(nv,tmpnv,2*n);
	tt=presentt;
	tmplit=literals;
	if(presentt==t)
	  {
	     val=2;
	  }
	else
	  {
	     val=1;
	  }
     }
   return val;
}

void change_pred()
{
   int i,j,k,numl,dell,fin;
   
   i=0;
   j=0;
   k=0;
   while(chk_predicate()==0)
     {
	if(*(*(ptmpclause+i)+2*n)<XSAT)
	  {
	     printf("clause %d includes only %d literals\n",
		    i,*(*(ptmpclause+i)+2*n));
	     exit(-1);
	  }
	while((numl=*(*(ptmpclause+i)+2*n))>XSAT)
	  {
	     dell=num_rand(0,numl);
	     k=0;
	     fin=0;
	     for(j=0; ((j<2*n)&&(fin==0)); j++)
	       {
		  if(*(*(ptmpclause+i)+j)>0)
		    {
		       k+=1;
		    }
		  if(k==dell+1)
		    {
		       *(*(ptmpclause+i)+j)-=1;
		       *(*(ptmpclause+i)+2*n)-=1;
		       literals+=1;
		       *(nv+j)+=1;
		       fin=1;
		    }
	       }
	  }
	i+=1;
     }
   for(i=0; i<t; i++)
     {
	fill_dat(*(pclause+i),2*n+1,0);
     }
   for(i=0; i<presentt; i++)
     {
	copy_dat(*(ptmpclause+i),*(pclause+i),2*n+1);
     }
   copy_dat(nv,tmpnv,2*n);
   tt=presentt;
   tmplit=literals;
}

int rmake_c()
{
   int i,j,num,lit,finish,val;
   
   finish=0;
   printf("Clauses except Random Ones: %d\n",tt);
   if(tt==0)
     {
	printf("Making failed\n");
        val=0;
     }
   else
     {
	fill_dat(rlit,2*n+1,1);
	for(i=tt; i<t; i++)
	  {
	     for(j=0; j<XSAT; j++)
	       {
		  finish=0;
		  while(finish==0)
		    {
		       num=num_rand(0,*(rlit+2*n));
		       lit=*(rlit+num);
		       if(*(tmpnv+lit)>0)
			 {
			    *(*(pclause+i)+lit)+=1;
			    *(*(pclause+i)+2*n)+=1;
			    *(tmpnv+lit)-=1;
			    tmplit-=1;
			    finish=1;
			 }
		       else
			 {
			    removel(rlit,num,*(rlit+2*n),2*n);
			 }
		    }
	       }
	  }
	val=1;
     }
   return val;
}

int rand_make_c()
{
   int l,*rmc,numc,c,numl,lit;

   printf("Clauses except Random Ones: %d\n",tt);
   l=t-tt;
   rmc=(int *)malloc(sizeof(int)*(l+1));
   fill_dat(rmc,l+1,1);
   fill_dat(rlit,2*n+1,1);
   while(*(rmc+l)!=0)
     {
	numc=num_rand(0,*(rmc+l));
	c=*(rmc+numc);
	if(*(*(pclause+tt+c)+2*n)<XSAT)
	  {
	     numl=num_rand(0,*(rlit+2*n));
	     lit=*(rlit+numl);
	     if(*(tmpnv+lit)>0)
	       {
		  *(*(pclause+tt+c)+lit)+=1;
		  *(*(pclause+tt+c)+2*n)+=1;
		  *(tmpnv+lit)-=1;
		  tmplit-=1;
	       }
	     else
	       {
		  removel(rlit,numl,*(rlit+2*n),2*n);
	       }
	  }
	else
	  {
	     removel(rmc,numc,*(rmc+l),l);
	  }
     }
   return 1;
}

void step4()
{
   if(rand_make_c()==0)
     {
	exit(-1);
     }
   else
     {
	printf("Clause Remove: %d\n",dn);
	out_lit();
	out_pred();
	dimacs_no();
	dimacs_out();
     }
}
     
void fail_out()
{
   int i;

   out_lit();
   printf("\n");
   printf(".....Failed Output......\n");
   printf("....Rest of Literals....\n");
   for(i=0; i<n; i++)
     {
	printf("N[%d]= %d    N[%d']= %d\n",
	       i+1,*(p_nv+i),i+1,*(n_nv+i));
     }
   printf("\n");
   printf("Total of Literals: %d\n",literals);
   printf("Clauses except Random Ones:  %d\n",tt);
   printf("Clause Remove             :  %d\n",dn);
}

void fail_pred()
{
   int i,j,samelit;

   printf("\n\n");
   printf("Failed Predicate\n");
   for(i=0; i<presentt; i++)
     {
	printf("(");
	for(j=0; j<n; j++)
	  {
	     samelit=*(*(ptmpclause+i)+j);
	     if(samelit >0)
	       {
		  while(samelit>0)
		    {
		       printf("%d ",j+1);
		       samelit-=1;
		    }
	       }
	     samelit=*(*(ptmpclause+i)+n+j);
	     if(samelit>0)
	       {
		  while(samelit>0)
		    {
		       printf("%d'",j+1);
		       samelit-=1;
		    }
	       }
	  }
	printf(")");
       }
   printf("\n");
}

void dimacs_no()
{
   printf("\n");
   printf("c\n");
   printf("c NOTE: Unsatisfiable\n");
   printf("c\n");
}


